Compare commits

...

30 Commits

Author SHA1 Message Date
AJ ONeal
8a70ae85b7 ref(ssh-pubkey): name file according to comment, if available 2024-05-16 23:03:50 +00:00
AJ ONeal
6172fba55f fix: update ssh-pubkey for modern 3072+ bit and ed25519 keys 2024-05-16 20:22:22 +00:00
AJ ONeal
24c51bef34 fix(ssh-pubkey): use POSIX-compliant cp -RPp 2024-05-16 20:12:02 +00:00
AJ ONeal
fbacd622ee ref(ssh-pubkey): prefer 'test ...' over '[ ... ]' 2024-05-16 19:48:05 +00:00
AJ ONeal
345d4fa146 ref(ssh-pubkey): prefer ~ over $HOME for unquoted paths 2024-05-16 19:46:19 +00:00
AJ ONeal
fa71ef9002 chore: remove junk file vim-things.sh 2024-05-16 19:35:05 +00:00
AJ ONeal
c431ce0b22 feat(webi-essentials+bsd): support 'pkg_add' 2024-01-15 23:01:01 -07:00
AJ ONeal
7ea58dcdfb fix(bsd): silence 'uname -o' error when not supported 2024-01-15 22:00:01 -07:00
AJ ONeal
67f361d35c fix(bsd): detect and use OpenBSD 'shasum' 2024-01-15 22:00:01 -07:00
AJ ONeal
05f33b1ff3 fix(bsd): use explicit untar 2024-01-15 22:00:00 -07:00
AJ ONeal
adef540665 doc(dashcore-utils): show the known mount rather than 'EXAMPLE' 2024-01-15 21:48:53 -07:00
AJ ONeal
7293a3de5f doc(dashcore-utils): conf for listen, daemon, and evonode 2024-01-15 21:48:53 -07:00
AJ ONeal
603cc96996 doc(dashd): typo 'bin/bin/' => 'bin/' 2024-01-15 21:48:53 -07:00
AJ ONeal
c5c258747e fix(dashcore-utils): show correct filename during download 2024-01-15 21:48:53 -07:00
AJ ONeal
141b56b694 fix(go-essentials): correctly silence 'command -v' 2024-01-15 21:48:53 -07:00
AJ ONeal
d306f7fc56 fix(dashcore-utils): run 'webi' by path, not WEBI_HOST url 2024-01-15 21:48:53 -07:00
AJ ONeal
90344c5365 fix(brew-update-service): install serviceman as needed 2024-01-15 21:46:24 -07:00
AJ ONeal
396e34da41 feat(pyenv+macos): install Command Line Tools for macOS 2024-01-15 21:46:24 -07:00
AJ ONeal
e00fe40725 feat: add macos commandlinetools (for pyenv, brew, etc) 2024-01-15 21:46:24 -07:00
AJ ONeal
63a08e8ace doc(pyenv): update deps, move Files, add ToC
f: doc(pyenv)
2024-01-15 21:46:23 -07:00
AJ ONeal
22f09bbf5c fix(webi-essentials): replace '==' bashism with '=' 2024-01-15 21:44:43 -07:00
Soren Richenberg
af6b09ef2a fix(windows): apply -File and quotations to webi.bat file to pass %USERPROFILE% as a single argument when it contains spaces 2024-01-15 21:44:43 -07:00
AJ ONeal
379a301bf3 fix(windows): 'powershell -File ...' to work with $HOME with spaces 2024-01-15 21:44:43 -07:00
AJ ONeal
73c5ea082c fix(sd+windows): correct install dir (had typo) 2024-01-15 21:44:42 -07:00
AJ ONeal
16d108e3d5 fix(fish): treat .app.zip as .zip for extraction 2024-01-15 16:23:14 -07:00
AJ ONeal
4738ba04b9 feat: add julia (programming language) 2024-01-11 15:20:12 -07:00
AJ ONeal
904ce1f2d6 fix(cache): set 'updated' to old date, correct typo 2024-01-07 21:04:01 -07:00
AJ ONeal
8bb6dec5d8 chore(release): bump to v1.1.1 2024-01-02 16:07:22 -07:00
AJ ONeal
ca03de16c6 fix(builds-cacher): fallback to setting build.name from build.download 2024-01-02 16:01:43 -07:00
AJ ONeal
11e1bf94f0 fix(ci): add GITHUB_TOKEN to ENVs for running tests 2024-01-02 15:59:57 -07:00
32 changed files with 860 additions and 112 deletions

View File

@@ -32,4 +32,6 @@ jobs:
- run: npm run fmt - run: npm run fmt
- run: npm ci - run: npm ci
- run: npm run lint - run: npm run lint
- run: npm run test - env:
GITHUB_TOKEN: ${{ github.token }}
run: npm run test

View File

@@ -0,0 +1,73 @@
'use strict';
let Path = require('node:path');
let BuildsCacher = require('./builds-cacher.js');
// let Parallel = require('./parallel.js');
var INSTALLERS_DIR = Path.join(__dirname, '..');
var CACHE_DIR = Path.join(__dirname, '../_cache');
async function main() {
let bc = BuildsCacher.create({
caches: CACHE_DIR,
installers: INSTALLERS_DIR,
});
bc.freshenRandomPackage(600 * 1000);
// let dirs = await bc.getProjectsByType();
// let projNames = Object.keys(dirs.valid);
let lastUpdate;
let projName = 'k9s';
{
let packages = await bc.getPackages({
//Releases: Releases,
name: projName,
date: new Date(),
});
lastUpdate = packages.updated;
console.info(
`Last update for '${projName}': ${packages.updated} (${packages.releases.length} assets)`,
);
}
console.info('Waiting 5s');
{
setTimeout(async function () {
let packages = await bc.getPackages({
//Releases: Releases,
name: projName,
date: new Date(),
});
console.info(
`Last update for '${projName}': ${packages.updated} (${packages.releases.length} assets)`,
);
if (lastUpdate < packages.updated) {
console.info(`PASS`);
} else {
console.info(`MAYBE fail`);
}
}, 5 * 1000);
}
//let parallel = 25;
//await Parallel.run(parallel, projNames, getAll);
//async function getAll(name) {
// void (await bc.getPackages({
// //Releases: Releases,
// name: name,
// date: new Date(),
// }));
//}
}
main()
.then(function () {
console.log('Done');
})
.catch(function (e) {
console.error(e.stack || e);
process.exit(1);
});

View File

@@ -130,6 +130,8 @@ async function readFirstBytes(path) {
let promises = {}; let promises = {};
async function getLatestBuilds(Releases, installersDir, cacheDir, name, date) { async function getLatestBuilds(Releases, installersDir, cacheDir, name, date) {
console.info(`[INFO] getLatestBuilds: ${name}`);
if (!Releases) { if (!Releases) {
Releases = require(`${installersDir}/${name}/releases.js`); Releases = require(`${installersDir}/${name}/releases.js`);
} }
@@ -323,17 +325,21 @@ BuildsCacher.create = function ({ ALL_TERMS, installers, caches }) {
let isoDate = date.toISOString(); let isoDate = date.toISOString();
let yearMonth = isoDate.slice(0, 7); let yearMonth = isoDate.slice(0, 7);
let dataFile = `${cacheDir}/${yearMonth}/${name}.json`; let dataFile = `${cacheDir}/${yearMonth}/${name}.json`;
let tsFile = `${cacheDir}/${yearMonth}/${name}.updated.txt`;
// let secondsStr = await Fs.readFile(tsFile, 'ascii').catch(function (err) { let tsDate;
// if (err.code !== 'ENOENT') { {
// throw err; let secondsStr = await Fs.readFile(tsFile, 'ascii').catch(function (err) {
// } if (err.code !== 'ENOENT') {
// return '0'; throw err;
// }); }
// secondsStr = secondsStr.trim(); return '0';
// let seconds = parseFloat(secondsStr) || 0; });
secondsStr = secondsStr.trim();
// let age = now - seconds; let seconds = parseFloat(secondsStr) || 0;
let ms = seconds * 1000;
tsDate = new Date(ms);
}
let projInfo = bc._caches[name]; let projInfo = bc._caches[name];
@@ -375,11 +381,14 @@ BuildsCacher.create = function ({ ALL_TERMS, installers, caches }) {
if (!projInfo) { if (!projInfo) {
projInfo = await getLatestBuilds(Releases, installersDir, cacheDir, name); projInfo = await getLatestBuilds(Releases, installersDir, cacheDir, name);
} }
transformAndUpdate(name, projInfo, meta, tsDate);
process.nextTick(async function () { process.nextTick(async function () {
let now = date.valueOf(); let now = date.valueOf();
let age = now - projInfo.updated; let age = now - projInfo.updated;
if (age < bc._staleAge) {
let fresh = age < bc._staleAge;
if (fresh) {
return; return;
} }
@@ -387,7 +396,6 @@ BuildsCacher.create = function ({ ALL_TERMS, installers, caches }) {
transformAndUpdate(name, projInfo, meta, date); transformAndUpdate(name, projInfo, meta, date);
}); });
transformAndUpdate(name, projInfo, meta, date);
return projInfo; return projInfo;
}; };
@@ -395,6 +403,7 @@ BuildsCacher.create = function ({ ALL_TERMS, installers, caches }) {
meta.packages = []; meta.packages = [];
let updated = date.valueOf(); let updated = date.valueOf();
Object.assign(projInfo, { name, updated }, meta); Object.assign(projInfo, { name, updated }, meta);
for (let build of projInfo.releases) { for (let build of projInfo.releases) {
let buildTarget = bc.classify(projInfo, build); let buildTarget = bc.classify(projInfo, build);
@@ -415,6 +424,10 @@ BuildsCacher.create = function ({ ALL_TERMS, installers, caches }) {
continue; continue;
} }
if (!build.name) {
build.name = build.download.replace(/.*\//, '');
}
build.target = buildTarget; build.target = buildTarget;
meta.packages.push(build); meta.packages.push(build);
} }
@@ -499,6 +512,7 @@ BuildsCacher.create = function ({ ALL_TERMS, installers, caches }) {
name: name, name: name,
date: new Date(), date: new Date(),
})); }));
console.info(`[INFO] freshenRandomPackage: ${name}`);
let hour = 60 * 60 * 1000; let hour = 60 * 60 * 1000;
let delay = minDelay; let delay = minDelay;
@@ -732,6 +746,7 @@ BuildsCacher.create = function ({ ALL_TERMS, installers, caches }) {
exts.push('.git'); exts.push('.git');
// Fallbacks // Fallbacks
// (we include everything to bubble an extract error over not found)
exts.push('.app.zip'); exts.push('.app.zip');
exts.push('.dmg'); exts.push('.dmg');
exts.push('.pkg'); exts.push('.pkg');

View File

@@ -20,7 +20,7 @@ bc.freshenRandomPackage(600 * 1000);
Builds.init = async function () { Builds.init = async function () {
bc.freshenRandomPackage(600 * 1000); bc.freshenRandomPackage(600 * 1000);
let dirs = await bc.getProjects(); let dirs = await bc.getProjectsByType();
let projNames = Object.keys(dirs.valid); let projNames = Object.keys(dirs.valid);
let parallel = 25; let parallel = 25;

View File

@@ -267,12 +267,23 @@ webi_bootstrap() { (
fn_checksum() { fn_checksum() {
a_filepath="${1}" a_filepath="${1}"
cmd_shasum='sha1sum' if command -v sha1sum > /dev/null; then
if command -v shasum > /dev/null; then sha1sum "${a_filepath}" | cut -d' ' -f1 | cut -c 1-8
cmd_shasum='shasum' return 0
fi fi
$cmd_shasum "${a_filepath}" | cut -d' ' -f1 | cut -c 1-8 if command -v shasum > /dev/null; then
shasum "${a_filepath}" | cut -d' ' -f1 | cut -c 1-8
return 0
fi
if command -v sha1 > /dev/null; then
sha1 "${a_filepath}" | cut -d'=' -f2 | cut -c 2-9
return 0
fi
echo >&2 " warn: no sha1 sum program"
date '+%F %H:%M'
} }
############################################## ##############################################

View File

@@ -93,7 +93,7 @@ Installers.renderBash = async function (
['WEBI_GIT_TAG', rel.git_tag], // TODO replace with branch ['WEBI_GIT_TAG', rel.git_tag], // TODO replace with branch
['WEBI_LTS', rel.lts], ['WEBI_LTS', rel.lts],
['WEBI_CHANNEL', rel.channel], ['WEBI_CHANNEL', rel.channel],
['WEBI_EXT', rel.ext.replace(/tar.*/, 'tar')], ['WEBI_EXT', rel.ext],
['WEBI_FORMATS', formats.join(',')], ['WEBI_FORMATS', formats.join(',')],
['WEBI_PKG_URL', rel.download], ['WEBI_PKG_URL', rel.download],
['WEBI_PKG_PATHNAME', pkgFile], ['WEBI_PKG_PATHNAME', pkgFile],

View File

@@ -197,20 +197,32 @@ __bootstrap_webi() {
my_dl_rel="$( my_dl_rel="$(
fn_sub_home "${WEBI_PKG_PATH}/${WEBI_PKG_FILE}" fn_sub_home "${WEBI_PKG_PATH}/${WEBI_PKG_FILE}"
)" )"
if [ "tar" = "$WEBI_EXT" ]; then if test "$WEBI_EXT" = "tar.zst"; then
echo " Extracting $(t_path "${my_dl_rel}")"
unzstd -c --keep "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" | tar xf -
elif test "$WEBI_EXT" = "tar.xz"; then
echo " Extracting $(t_path "${my_dl_rel}")"
unxz -c --keep "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" | tar xf -
elif test "$WEBI_EXT" = "tar.gz"; then
echo " Extracting $(t_path "${my_dl_rel}")"
tar xzf "${WEBI_PKG_PATH}/$WEBI_PKG_FILE"
elif test "$WEBI_EXT" = "tar.bz2"; then
echo " Extracting $(t_path "${my_dl_rel}")"
tar xjf "${WEBI_PKG_PATH}/$WEBI_PKG_FILE"
elif test "$WEBI_EXT" = "tar"; then
echo " Extracting $(t_path "${my_dl_rel}")" echo " Extracting $(t_path "${my_dl_rel}")"
tar xf "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" tar xf "${WEBI_PKG_PATH}/$WEBI_PKG_FILE"
elif [ "zip" = "$WEBI_EXT" ]; then elif test "$WEBI_EXT" = "zip" || test "$WEBI_EXT" = "app.zip"; then
echo " Extracting $(t_path "${my_dl_rel}")" echo " Extracting $(t_path "${my_dl_rel}")"
unzip "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" > __unzip__.log unzip "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" > __unzip__.log
elif [ "exe" = "$WEBI_EXT" ]; then elif test "$WEBI_EXT" = "exe"; then
echo " Moving $(t_path "${my_dl_rel}")" echo " Moving $(t_path "${my_dl_rel}")"
echo " to $(t_path "$(fn_sub_home "$(pwd)")")" echo " to $(t_path "$(fn_sub_home "$(pwd)")")"
mv "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" . mv "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" .
elif [ "git" = "$WEBI_EXT" ]; then elif test "$WEBI_EXT" = "git"; then
echo " Moving $(t_path "${my_dl_rel}")" echo " Moving $(t_path "${my_dl_rel}")"
mv "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" . mv "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" .
elif [ "xz" = "$WEBI_EXT" ]; then elif test "$WEBI_EXT" = "xz"; then
echo " Inflating $(t_path "${my_dl_rel}")" echo " Inflating $(t_path "${my_dl_rel}")"
unxz -c "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" > "$(basename "$WEBI_PKG_FILE")" unxz -c "${WEBI_PKG_PATH}/$WEBI_PKG_FILE" > "$(basename "$WEBI_PKG_FILE")"
else else
@@ -776,12 +788,23 @@ webi_upgrade() { (
fn_checksum() { fn_checksum() {
a_filepath="${1}" a_filepath="${1}"
cmd_shasum='sha1sum' if command -v sha1sum > /dev/null; then
if command -v shasum > /dev/null; then sha1sum "${a_filepath}" | cut -d' ' -f1 | cut -c 1-8
cmd_shasum='shasum' return 0
fi fi
$cmd_shasum "${a_filepath}" | cut -d' ' -f1 | cut -c 1-8 if command -v shasum > /dev/null; then
shasum "${a_filepath}" | cut -d' ' -f1 | cut -c 1-8
return 0
fi
if command -v sha1 > /dev/null; then
sha1 "${a_filepath}" | cut -d'=' -f2 | cut -c 2-9
return 0
fi
echo >&2 " warn: no sha1 sum program"
date '+%F %H:%M'
} }
############################################## ##############################################

View File

@@ -6,15 +6,23 @@ main() { (
sed '1,/^#~\/.local\/bin\/brew-updater/d' "${0}" > ~/.local/bin/brew-update-hourly sed '1,/^#~\/.local\/bin\/brew-updater/d' "${0}" > ~/.local/bin/brew-update-hourly
chmod a+x ~/.local/bin/brew-update-hourly chmod a+x ~/.local/bin/brew-update-hourly
echo "Checking for serviceman..."
if ! command -v serviceman > /dev/null; then
"$HOME/.local/bin/webi" serviceman
export PATH="$HOME/.local/bin:$PATH"
serviceman --version
fi
env PATH="$PATH" serviceman add --user \ env PATH="$PATH" serviceman add --user \
--workdir ~/.local/opt/brew/ \ --workdir ~/.local/opt/brew/ \
--name sh.brew.updater -- \ --name sh.brew.updater -- \
~/.local/bin/brew-update-hourly ~/.local/bin/brew-update-hourly
); } ); }
if main; then if ! main; then
exit 0 exit 1
fi fi
exit 0
#~/.local/bin/brew-updater #~/.local/bin/brew-updater
#!/bin/sh #!/bin/sh

View File

@@ -0,0 +1,55 @@
---
title: XCode Command Line Tools
homepage: https://webinstall.dev/commandlinetools
tagline: |
The XCode Command Line Tools include git, swift, make, clang, and other developer tools
---
## Cheat Sheet
> The developer tools provided by Apple for macOS.
- git
- swift
- make
- clang
- etc
This is also part of [webi-essentials](../webi-essentials/).
## Table of Contents
- Files
- Manual Install
- macOS
- Linux
- Alpine
- Windows
### Files
These are the files / directories that are created and/or modified with this
install:
```sh
/Library/Developer/CommandLineTools/
```
### How to Install Manually
It's very easy to start the installer:
```sh
xcode-select --install
```
The trick is to also have a mechanism to know when it has finished:
```sh
while ! test -x /Library/Developer/CommandLineTools/usr/bin/git ||
! test -x /Library/Developer/CommandLineTools/usr/bin/make; do
sleep 0.25
done
echo "Command Line Tools Installed"
```

View File

@@ -0,0 +1,62 @@
#!/bin/sh
set -e
set -u
fn_install_xcode_commandlinetools() { (
b_os="$(uname -s)"
if test "${b_os}" != 'Darwin'; then
echo >&2 'XCode Command Line Tools are for macOS only'
return 1
fi
# streamline the output to be pretty
fn_check_pkg '/Library/Developer/CommandLineTools/usr/bin/clang' 'clang'
fn_check_pkg '/Library/Developer/CommandLineTools/usr/bin/git' 'git'
fn_check_pkg '/Library/Developer/CommandLineTools/usr/bin/make' 'make'
echo >&2 ""
# git
if xcode-select -p > /dev/null 2> /dev/null; then
echo ""
return 0
fi
cmd_xcode_cli_tools_install="xcode-select --install"
echo " Running $(t_cmd "${cmd_xcode_cli_tools_install}")"
$cmd_xcode_cli_tools_install 2> /dev/null
echo ""
echo ">>> $(t_attn 'ACTION REQUIRED') <<<"
echo ""
echo " $(t_attn "Click") '$(t_bold 'Install')' $(t_attn "in the pop-up")"
echo " (it may appear $(t_em 'under') this window)"
echo ""
echo "^^^ $(t_attn 'ACTION REQUIRED') ^^^"
echo ""
printf " waiting %s to finish installing Command Line Developer Tools ..." "$(t_em 'for you')"
while ! test -x /Library/Developer/CommandLineTools/usr/bin/git ||
! test -x /Library/Developer/CommandLineTools/usr/bin/make; do
sleep 0.25
done
echo " $(t_info 'OK')"
echo " Installed to $(t_path '/Library/Developer/CommandLineTools/')"
sleep 1
); }
fn_check_pkg() { (
a_pkg="${1}"
a_pkgname="${2:-$a_pkg}"
printf >&2 ' %s %s %s' \
"$(t_dim "Checking for")" \
"$(t_pkg "${a_pkgname}")" \
"$(t_dim "...")"
if command -v "${a_pkg}" > /dev/null; then
echo >&2 " $(t_dim 'OK')"
return 0
fi
echo >&2 ' missing'
); }
fn_install_xcode_commandlinetools

View File

@@ -1,7 +1,14 @@
# for exposing RPCs, building APIs
txindex=1 txindex=1
addressindex=1 addressindex=1
timestampindex=1 timestampindex=1
spentindex=1 spentindex=1
# listen as server (explicit default)
listen=1
# because its already run as a service (systemd, openrc)
daemon=0
# for evonodes
#server=1
[main] [main]
rpcuser=RPCUSER_MAIN rpcuser=RPCUSER_MAIN

View File

@@ -17,7 +17,7 @@ fn_usage() { (
); } ); }
fn_datadir_help() { ( fn_datadir_help() { (
my_vol="${1:-}" my_vol="${1}"
my_user="$( my_user="$(
id -n -u id -n -u
)" )"
@@ -25,6 +25,7 @@ fn_datadir_help() { (
id -n -g id -n -g
)" )"
my_mount="$(dirname "${my_vol}")"
echo >&2 "" echo >&2 ""
echo >&2 "ERROR" echo >&2 "ERROR"
echo >&2 " '${my_vol}' is not writable" echo >&2 " '${my_vol}' is not writable"
@@ -32,8 +33,8 @@ fn_datadir_help() { (
echo >&2 "SOLUTION" echo >&2 "SOLUTION"
echo >&2 " 1. Mount a large (50gb+) volume" echo >&2 " 1. Mount a large (50gb+) volume"
echo >&2 "" echo >&2 ""
echo >&2 " sudo mkdir -p /mnt/EXAMPLE" echo >&2 " sudo mkdir -p ${my_mount}"
echo >&2 " sudo mount /dev/sdx1 /mnt/EXAMPLE" echo >&2 " sudo mount /dev/sdx1 ${my_mount}"
echo >&2 "" echo >&2 ""
echo >&2 " 2. Create a 'dashcore' inside of it" echo >&2 " 2. Create a 'dashcore' inside of it"
echo >&2 "" echo >&2 ""
@@ -111,7 +112,7 @@ fn_srv_install() { (
echo "Installing 'serviceman'..." echo "Installing 'serviceman'..."
echo "" echo ""
{ {
curl -fsSL "${WEBI_HOST}/serviceman" | sh "$HOME/.local/bin/webi" serviceman
} > /dev/null } > /dev/null
# shellcheck disable=SC1090 # shellcheck disable=SC1090

View File

@@ -5,32 +5,38 @@ set -u
__install_dashcore_utils() { __install_dashcore_utils() {
webi_download \ webi_download \
"$WEBI_HOST/packages/dashcore-utils/dash-qt-hd" \ "$WEBI_HOST/packages/dashcore-utils/dash-qt-hd" \
"$HOME/.local/bin/dash-qt-hd" "$HOME/.local/bin/dash-qt-hd" \
"dash-qt-hd"
chmod a+x "$HOME/.local/bin/dash-qt-hd" chmod a+x "$HOME/.local/bin/dash-qt-hd"
webi_download \ webi_download \
"$WEBI_HOST/packages/dashcore-utils/dash-qt-testnet" \ "$WEBI_HOST/packages/dashcore-utils/dash-qt-testnet" \
"$HOME/.local/bin/dash-qt-testnet" "$HOME/.local/bin/dash-qt-testnet" \
"dash-qt-testnet"
chmod a+x "$HOME/.local/bin/dash-qt-testnet" chmod a+x "$HOME/.local/bin/dash-qt-testnet"
webi_download \ webi_download \
"$WEBI_HOST/packages/dashcore-utils/dashd-hd" \ "$WEBI_HOST/packages/dashcore-utils/dashd-hd" \
"$HOME/.local/bin/dashd-hd" "$HOME/.local/bin/dashd-hd" \
"dashd-hd"
chmod a+x "$HOME/.local/bin/dashd-hd" chmod a+x "$HOME/.local/bin/dashd-hd"
webi_download \ webi_download \
"$WEBI_HOST/packages/dashcore-utils/dashd-testnet" \ "$WEBI_HOST/packages/dashcore-utils/dashd-testnet" \
"$HOME/.local/bin/dashd-testnet" "$HOME/.local/bin/dashd-testnet" \
"dashd-testnet"
chmod a+x "$HOME/.local/bin/dashd-testnet" chmod a+x "$HOME/.local/bin/dashd-testnet"
webi_download \ webi_download \
"$WEBI_HOST/packages/dashcore-utils/dashd-hd-service-install" \ "$WEBI_HOST/packages/dashcore-utils/dashd-hd-service-install" \
"$HOME/.local/bin/dashd-hd-service-install" "$HOME/.local/bin/dashd-hd-service-install" \
"dashd-hd-service-install"
chmod a+x "$HOME/.local/bin/dashd-hd-service-install" chmod a+x "$HOME/.local/bin/dashd-hd-service-install"
webi_download \ webi_download \
"$WEBI_HOST/packages/dashcore-utils/dashd-testnet-service-install" \ "$WEBI_HOST/packages/dashcore-utils/dashd-testnet-service-install" \
"$HOME/.local/bin/dashd-testnet-service-install" "$HOME/.local/bin/dashd-testnet-service-install" \
"dashd-testnet-service-install"
chmod a+x "$HOME/.local/bin/dashd-testnet-service-install" chmod a+x "$HOME/.local/bin/dashd-testnet-service-install"
if ! test -e "${HOME}/.dashcore"; then if ! test -e "${HOME}/.dashcore"; then
@@ -44,7 +50,8 @@ __install_dashcore_utils() {
webi_download \ webi_download \
"$WEBI_HOST/packages/dashcore-utils/dash.example.conf" \ "$WEBI_HOST/packages/dashcore-utils/dash.example.conf" \
"$HOME/.dashcore/dash.example.conf" "$HOME/.dashcore/dash.example.conf" \
"dash.example.conf"
if ! grep -q rpcuser ~/.dashcore/dash.conf; then if ! grep -q rpcuser ~/.dashcore/dash.conf; then
cat ~/.dashcore/dash.example.conf >> ~/.dashcore/dash.conf cat ~/.dashcore/dash.example.conf >> ~/.dashcore/dash.conf

View File

@@ -24,7 +24,7 @@ install:
~/.config/envman/PATH.env ~/.config/envman/PATH.env
~/.dashcore/dash.conf ~/.dashcore/dash.conf
~/.dashcore/wallets/ ~/.dashcore/wallets/
~/.local/bin/bin/dashd-hd-service-install ~/.local/bin/dashd-hd-service-install
~/.local/opt/dashcore/ ~/.local/opt/dashcore/
/mnt/<BLK_VOL>/dashcore/ /mnt/<BLK_VOL>/dashcore/
``` ```

View File

@@ -3,7 +3,7 @@ set -e
set -u set -u
__run_go_essentials() { __run_go_essentials() {
if ! command -v go 2> /dev/null; then if ! command -v go > /dev/null; then
"$HOME/.local/bin/webi" "go@${WEBI_TAG}" "$HOME/.local/bin/webi" "go@${WEBI_TAG}"
fi fi

128
julia/README.md Normal file
View File

@@ -0,0 +1,128 @@
---
title: Julia
homepage: https://julialang.org/
tagline: |
Julia: A Language for Data Science, Visualization, and Machine Learning
---
To update or switch versions, run `webi julia@stable` (or `@v1.10`, `@beta`,
etc).
## Cheat Sheet
> Julia is a programming language for Data Science - a far better alternative to
> (or plugin for) Python when performance matters.
## Table of Contents
- Files
- Hello World
- Compile for Distribution
- Vim Plugin
### Files
These are the files / directories that are created and/or modified with this
install:
```text
~/.config/envman/PATH.env
~/.local/opt/julia/
```
### How to create a Hello World with Julia
Try out the REPL by coping and pasting the code below (it'll print some nice
ASCII art to the console):
```sh
julia -i
```
```julia
function mandelbrot(a)
z = 0
for i=1:50
z = z^2 + a
end
return z
end
for y=1.0:-0.05:-1.0
for x=-2.0:0.0315:0.5
abs(mandelbrot(complex(x, y))) < 2 ? print("*") : print(" ")
end
println()
end
```
Or write the program to `./mandelbrot.jl` and run it:
```sh
julia ./mandelbrot.jl
```
## How to Build a Distributable Binary with Julia
Here's an example project that you can build:
1. Clone and enter the example project
```sh
git clone --depth=1 https://github.com/JuliaLang/PackageCompiler.jl ./PackageCompiler
pushd ./PackageCompiler/examples
```
2. Run Julia in project mode
```sh
julia -q --project
```
3. Compile the binary
```julia
using PackageCompiler
create_app("MyApp", "MyAppCompiled")
exit()
```
4. Test & Enjoy
```sh
./MyAppCompiled/bin/MyApp foo bar --julia-args -t4
```
See also:
- <https://docs.juliahub.com/PackageCompiler/MMV8C/2.1.16/apps.html>
- <https://github.com/JuliaLang/PackageCompiler.jl/tree/master/examples/MyApp>
## How to Install the Language Server (for VSCode, Vim, etc)
Open the Julia REPL and add `LanguageServer`:
```sh
julia -i
```
```jl
using Pkg
Pkg.add("LanguageServer")
Pkg.add("SymbolServer")
```
You'll need to reinstall if you switch environments.
## How to Install the Julia Vim Plugin
`julia-vim` adds support for:
- Latex-to-Unicode
- jumping from between start and end of blocks with `%` \
(and other block jump sequences)
```sh
mkdir -p ~/.vim/pack/plugins/start
git clone https://github.com/JuliaEditorSupport/julia-vim.git \
~/.vim/pack/plugins/start/julia-vim
```
Usage Examples:
- `\alpha<tab>` will produce `α` \
(meaning typing `\alpha` and hitting the `tab` key)
- Hitting `%` on an `end` will take you to the `function` or `for`, etc

56
julia/install.ps1 Normal file
View File

@@ -0,0 +1,56 @@
#!/usr/bin/env pwsh
#################
# Install julia #
#################
# Every package should define these variables
$pkg_cmd_name = "julia"
$pkg_dst_cmd = "$Env:USERPROFILE\.local\opt\julia\bin\julia.exe"
$pkg_dst_bin = "$Env:USERPROFILE\.local\opt\julia\bin"
$pkg_dst_dir = "$Env:USERPROFILE\.local\opt\julia"
$pkg_dst = "$pkg_dst_dir"
$pkg_src_cmd = "$Env:USERPROFILE\.local\opt\julia-v$Env:WEBI_VERSION\bin\julia.exe"
$pkg_src_dir = "$Env:USERPROFILE\.local\opt\julia-v$Env:WEBI_VERSION"
$pkg_src = "$pkg_src_dir"
New-Item "$Env:USERPROFILE\Downloads\webi" -ItemType Directory -Force | Out-Null
$pkg_download = "$Env:USERPROFILE\Downloads\webi\$Env:WEBI_PKG_FILE"
# Fetch archive
IF (!(Test-Path -Path "$pkg_download")) {
Write-Output "Downloading julia from $Env:WEBI_PKG_URL to $pkg_download"
& curl.exe -A "$Env:WEBI_UA" -fsSL "$Env:WEBI_PKG_URL" -o "$pkg_download.part"
& Move-Item "$pkg_download.part" "$pkg_download"
}
IF (!(Test-Path -Path "$pkg_src_dir")) {
Write-Output "Installing julia"
# TODO: create package-specific temp directory
# Enter tmp
Push-Location .local\tmp
# Remove any leftover tmp cruft
Remove-Item -Path ".\julia*" -Recurse -ErrorAction Ignore
# Unpack archive file into this temporary directory
# Windows BSD-tar handles zip. Imagine that.
Write-Output "Unpacking $pkg_download"
& tar xf "$pkg_download"
# Settle unpacked archive into place
Write-Output "Install Location: $pkg_src_cmd"
Move-Item -Path ".\julia*" -Destination "$pkg_src_dir"
# Exit tmp
Pop-Location
}
Write-Output "Copying into '$pkg_dst' from '$pkg_src'"
Remove-Item -Path "$pkg_dst" -Recurse -ErrorAction Ignore | Out-Null
Copy-Item -Path "$pkg_src" -Destination "$pkg_dst" -Recurse
webi_path_add "$pkg_dst_bin"
& "$pkg_dst_cmd" --version

47
julia/install.sh Normal file
View File

@@ -0,0 +1,47 @@
#!/bin/sh
# shellcheck disable=SC2034
# "'pkg_cmd_name' appears unused. Verify it or export it."
__init_julia() {
set -e
set -u
##################
# Install julia #
##################
# Every package should define these 6 variables
pkg_cmd_name="julia"
pkg_dst_cmd="$HOME/.local/opt/julia/bin/julia"
pkg_dst_dir="$HOME/.local/opt/julia"
pkg_dst="$pkg_dst_dir"
pkg_src_cmd="$HOME/.local/opt/julia-v$WEBI_VERSION/bin/julia"
pkg_src_dir="$HOME/.local/opt/julia-v$WEBI_VERSION"
pkg_src="$pkg_src_dir"
# pkg_install must be defined by every package
pkg_install() {
# ~/.local/opt/julia-v3.27.0/
mkdir -p "$(dirname "${pkg_src_dir}")"
# mv ./julia-*/ ~/.local/opt/julia-v3.27.0/
mv ./julia-*/ "${pkg_src_dir}"
}
# pkg_get_current_version is recommended, but not required
pkg_get_current_version() {
# 'julia --version' has output in this format:
# julia version 1.10.0-rc1
# This trims it down to just the version number:
# 1.10.0-rc1
julia --version 2> /dev/null |
head -n 1 |
cut -d ' ' -f 3
}
}
__init_julia

145
julia/releases.js Normal file
View File

@@ -0,0 +1,145 @@
'use strict';
var osMap = {
winnt: 'windows',
mac: 'darwin',
};
var archMap = {
armv7l: 'armv7',
i686: 'x86',
powerpc64le: 'ppc64le',
};
async function getAllReleases() {
let all = {
releases: [],
download: '',
_names: ['julia', 'macaarch64'],
};
let resp = await fetch(
'https://julialang-s3.julialang.org/bin/versions.json',
{
headers: {
Accept: 'application/json',
},
},
);
let buildsByVersion = await resp.json();
/*
{
"url": "https://julialang-s3.julialang.org/bin/mac/aarch64/1.9/julia-1.9.4-macaarch64.tar.gz",
"triplet": "aarch64-apple-darwin14",
"kind": "archive",
"arch": "aarch64",
"asc": "-----BEGIN PGP SIGNATURE-----\n\niQIzBAABCAAdFiEENnPfUp2QSUd/drN1ZuPH3APW5JUFAmVTQBcACgkQZuPH3APW\n5JWUqw//QF/CJLAxXZdcXqpBulLUs/AX+x/8aERGcKxZqfeYOwA5efOzma8sASa/\nUzYCLp9E31x/RMDoZah6vPRRjBR+uVI6CLlXCCCmbAJP3lD2vlcY9LKe2/7s3Ba8\nhwITRaL6R5zNr+YfSHW1Hoj2tWgAQh9Y+Te7bP3jzwp5dlFygFO0pzoN+aeJbPNA\nbgT0ry8tgh78/tgNjgt4Ev3E2t3ehhrDGK4tgkkKieO6sdFz8jOacZVZkR1kLVEg\nMBIqmqZfk+5/HMf/6gHwd5GOXW8+GakN7vYXO+9VFETA2EiD5Z5k4Edq/VrNCn4O\npC6WHpBmVBBYX4aQtHkJyQaV8PtFd1j9338jUWlDaa6BVtX2hjRtU1k1oLZB1TTX\nl4awzYgFqdCRnFmOtzTdMDBcfedOiIHdTyxXPjJCX3i0GXmeuk89e5dE4P6sTT9n\n24GeBVQgMaXuNorg9L0oKrsQ8RDT20yEnVbfhy4Cvoq7dNIks6IxLZt10tjJFp1j\n0oJ5f6KucGyqFM9UhXRcuLj8Z+Q+JDzBs5c2pPe/bEzv6nChRNv252e5dve17esg\nK7tHkhXzM+6wl60oyRtpWghOubXyBDsNu1MH3qC9lWy3wmWuMN7no+yX0vGFyhMT\naxjLJSeYdccKD3SuzYotp3XwBKk05PFX9lWy0vuIjVj1sGWcES8=\n=G1tO\n-----END PGP SIGNATURE-----\n",
"sha256": "67542975e86102eec95bc4bb7c30c5d8c7ea9f9a0b388f0e10f546945363b01a",
"size": 119559478,
"version": "1.9.4",
"os": "mac",
"extension": "tar.gz"
}
*/
let versions = Object.keys(buildsByVersion);
for (let version of versions) {
let release = buildsByVersion[version];
// let odd = isOdd(asset.filename);
// if (odd) {
// return;
// }
for (let build of release.files) {
// // For debugging
// let paths = build.url.split('/');
// let extlen = build.extension.length + 1;
// let name = paths.at(-1);
// name = name.replace(`-${build.version}`, '');
// name = name.slice('julia-'.length);
// name = name.slice(0, -extlen);
// console.log(`name: ${name}`);
// console.log(`triplet: ${build.triplet}`);
// console.log(`arch: ${build.arch}`);
// console.log(`os: ${build.os}`);
// console.log(`kind: ${build.kind}`);
// console.log(`extension: ${build.extension}`);
// console.log(`version: ${build.version}`);
if (build.kind === 'installer') {
continue;
}
let arch = archMap[build.arch] || build.arch || '-';
let os = osMap[build.os] || build.os || '-';
let libc = '';
let hardMusl = /\b(musl)\b/.test(build.url);
if (hardMusl) {
libc = 'musl';
} else if (os === 'linux') {
libc = 'gnu';
}
let webiBuild = {
version: build.version,
_version: build.version,
lts: false,
channel: '', // autodetect by filename (-beta1, -alpha1, -rc1)
date: '1970-01-01', // the world may never know
os: os,
arch: arch,
libc: libc,
_musl: hardMusl,
ext: '', // let normalize run the split/test/join
hash: '-', // build.sha256 not ready to standardize this yet
download: build.url,
};
all.releases.push(webiBuild);
}
}
all.releases.sort(sortByVersion);
return all;
}
function sortByVersion(a, b) {
let [aVer, aPre] = a.version.split('-');
let [bVer, bPre] = b.version.split('-');
let aVers = aVer.split('.');
let bVers = bVer.split('.');
for (let i = 0; i < 3; i += 1) {
aVers[i] = aVers[i].padStart(4, '0');
bVers[i] = bVers[i].padStart(4, '0');
}
aVer = aVers.join('.');
if (aPre) {
aVer += `-${aPre}`;
}
bVer = bVers.join('.');
if (bPre) {
bVer += `-${aPre}`;
}
if (aVer > bVer) {
return -1;
}
if (aVer < bVer) {
return 1;
}
return 0;
}
module.exports = getAllReleases;
if (module === require.main) {
getAllReleases().then(function (all) {
all = require('../_webi/normalize.js')(all);
all.releases = all.releases.slice(0, 10);
console.info(JSON.stringify(all, null, 2));
});
}

4
package-lock.json generated
View File

@@ -1,12 +1,12 @@
{ {
"name": "@webinstall/webi-installers", "name": "@webinstall/webi-installers",
"version": "1.1.0", "version": "1.1.1",
"lockfileVersion": 3, "lockfileVersion": 3,
"requires": true, "requires": true,
"packages": { "packages": {
"": { "": {
"name": "@webinstall/webi-installers", "name": "@webinstall/webi-installers",
"version": "1.1.0", "version": "1.1.1",
"license": "MPL-2.0", "license": "MPL-2.0",
"dependencies": { "dependencies": {
"@root/request": "^1.9.2", "@root/request": "^1.9.2",

View File

@@ -1,7 +1,7 @@
{ {
"name": "@webinstall/webi-installers", "name": "@webinstall/webi-installers",
"private": true, "private": true,
"version": "1.1.0", "version": "1.1.1",
"description": "webinstall script repository", "description": "webinstall script repository",
"main": "_webi/", "main": "_webi/",
"scripts": { "scripts": {

View File

@@ -13,7 +13,7 @@ function Repair-MissingCommand {
Return Return
} }
& $HOME\.local\bin\webi-pwsh.ps1 $Package & "$HOME\.local\bin\webi-pwsh.ps1" $Package
$null = Sync-EnvPath $null = Sync-EnvPath
} }

View File

@@ -15,7 +15,7 @@ function Repair-MissingCommand {
Return Return
} }
& $HOME\.local\bin\webi-pwsh.ps1 $Package & "$HOME\.local\bin\webi-pwsh.ps1" $Package
$null = Sync-EnvPath $null = Sync-EnvPath
} }
@@ -47,7 +47,7 @@ function Install-PwshEssential {
Repair-MissingCommand -Name "PowerShell Core" -Package "pwsh" -Command "pwsh" Repair-MissingCommand -Name "PowerShell Core" -Package "pwsh" -Command "pwsh"
# Fetch PSScriptAnalyzer (fmt, lint, fix) # Fetch PSScriptAnalyzer (fmt, lint, fix)
& $HOME\.local\bin\webi-pwsh.ps1 psscriptanalyzer & "$HOME\.local\bin\webi-pwsh.ps1" psscriptanalyzer
# Fetch shorthand commands to fmt, lint, & fix # Fetch shorthand commands to fmt, lint, & fix
$ScriptNames = , "pwsh-fmt", "pwsh-fix", "pwsh-lint" $ScriptNames = , "pwsh-fmt", "pwsh-fix", "pwsh-lint"

View File

@@ -7,22 +7,6 @@ tagline: |
To update run `pyenv update`. To update run `pyenv update`.
### Files
These are the files / directories that are created and/or modified with this
install:
```sh
~/.config/envman/PATH.env
~/.pyenv/bin/
~/.pyenv/shims/
# pyenv also loads shell hooks via
~/.bashrc
~/.config/fish/config.fish
~/.zshrc
```
### How to Install pyenv on macOS ### How to Install pyenv on macOS
Install Xcode tools first: Install Xcode tools first:
@@ -38,11 +22,21 @@ Make sure that you already have the necessary build tools installed:
```sh ```sh
# required # required
sudo apt update sudo apt update
sudo apt install -y build-essential zlib1g-dev libssl-dev sudo apt install -y build-essential zlib1g-dev libssl-dev \
libreadline-dev liblzma-dev
# recommended # recommended
sudo apt install -y libreadline-dev libsqlite3-dev \ sudo apt install -y libsqlite3-dev libffi-dev libbz2-dev
libffi-dev libbz2-dev liblzma-dev ```
### How to Install pyenv on Alpine
```sh
sudo apk add \
bash \
build-base \
git \
zlib-dev
``` ```
## Cheat Sheet ## Cheat Sheet
@@ -82,6 +76,34 @@ Revert back to your system python:
pyenv global system pyenv global system
``` ```
## Table of Contents
- Files
- List Installable Versions
- Install a Specific Version
- Install Local to a Project
- `virtualenv`s
- List Existing
- Create New
- Activate / Deactivate
- Delete
### Files
These are the files / directories that are created and/or modified with this
install:
```sh
~/.config/envman/PATH.env
~/.pyenv/bin/
~/.pyenv/shims/
# pyenv also loads shell hooks via
~/.bashrc
~/.config/fish/config.fish
~/.zshrc
```
### List all available python version ### List all available python version
```sh ```sh

View File

@@ -4,6 +4,13 @@ __init_pyenv() {
set -e set -e
set -u set -u
b_os="$(uname -s)"
if test "${b_os}" = 'Darwin'; then
if ! test -x /Library/Developer/CommandLineTools/usr/bin/git; then
"$HOME/.local/bin/webi" commandlinetools
fi
fi
curl -fsSL https://github.com/pyenv/pyenv-installer/raw/master/bin/pyenv-installer | bash curl -fsSL https://github.com/pyenv/pyenv-installer/raw/master/bin/pyenv-installer | bash
if [ ! -f ~/.bashrc ] || ! grep -q 'pyenv init' ~/.bashrc; then if [ ! -f ~/.bashrc ] || ! grep -q 'pyenv init' ~/.bashrc; then

View File

@@ -45,7 +45,7 @@ IF (!(Test-Path -Path "$pkg_src_cmd")) {
# Settle unpacked archive into place # Settle unpacked archive into place
Write-Output "Install Location: $pkg_src_cmd" Write-Output "Install Location: $pkg_src_cmd"
New-Item "$pkg_src_bin" -ItemType Directory -Force | Out-Null New-Item "$pkg_src_bin" -ItemType Directory -Force | Out-Null
Move-Item -Path "b\*\release\sd.exe" -Destination "$pkg_src_bin" Move-Item -Path "sd-*\sd.exe" -Destination "$pkg_src_bin"
# Exit tmp # Exit tmp
Pop-Location Pop-Location
} }

99
ssh-pubkey/ssh-pubkey Normal file → Executable file
View File

@@ -2,43 +2,102 @@
set -e set -e
set -u set -u
fn_warn_rsa() { (
echo 'WARNING'
echo ' ~/.ssh/id_rsa is less than the required 3072 bits'
echo ' (some modern services will reject your key)'
echo ''
echo 'SOLUTION'
echo ' Generate a new key, and update accordingly'
my_ts="$(date -u "+%F_%H.%M.%S")"
echo ''
echo ' # OPTION 1: Generate a more efficient, ED25519 256-bit key'
echo ' # and update your ~/.ssh/config accordingly'
echo " mv ~/.ssh/id_rsa ~/.ssh/id_rsa.${my_ts}.bak"
# shellcheck disable=SC2016
echo ' ssh-keygen -t ed25519 -f ~/.ssh/id_ed25519 -q -N ""'
echo " echo 'Host *
IdentityFile ~/.ssh/id_ed25519
IdentityFile ~/.ssh/id_rsa.${my_ts}.bak' >> ~/.ssh/config"
echo ''
echo ' # OPTION 2: Generate a larger, 4096-bit RSA key"'
echo ' # and update your ~/.ssh/config accordingly'
echo " mv ~/.ssh/id_rsa ~/.ssh/id_rsa.${my_ts}.bak"
# shellcheck disable=SC2016
echo ' ssh-keygen -t rsa -b 4096 -f ~/.ssh/id_rsa -q -N ""'
echo " echo 'Host *
IdentityFile ~/.ssh/id_rsa
IdentityFile ~/.ssh/id_rsa.${my_ts}.bak' >> ~/.ssh/config"
); }
main() { main() {
if [ ! -d "$HOME/.ssh" ]; then if ! test -d ~/.ssh; then
mkdir -p "$HOME/.ssh/" mkdir -p ~/.ssh/
chmod 0700 "$HOME/.ssh/" chmod 0700 ~/.ssh/
fi fi
if [ ! -f "$HOME/.ssh/config" ]; then if ! test -f ~/.ssh/config; then
# for the benefit of VSCode # for the benefit of VSCode
touch "$HOME/.ssh/config" touch ~/.ssh/config
chmod 0644 "$HOME/.ssh/config" chmod 0644 ~/.ssh/config
fi fi
if [ ! -f "$HOME/.ssh/authorized_keys" ]; then if ! test -f ~/.ssh/authorized_keys; then
touch "$HOME/.ssh/authorized_keys" touch ~/.ssh/authorized_keys
chmod 0600 "$HOME/.ssh/authorized_keys" chmod 0600 ~/.ssh/authorized_keys
fi fi
if [ ! -f "$HOME/.ssh/id_rsa" ]; then my_keytype=''
ssh-keygen -b 2048 -t rsa -f "$HOME/.ssh/id_rsa" -q -N "" if test -f ~/.ssh/id_ed25519; then
my_keytype='ed25519'
if ! test -f ~/.ssh/id_ed25519.pub; then
echo >&2 ""
ssh-keygen -y -f ~/.ssh/id_ed25519 > ~/.ssh/id_ed25519.pub
fi
elif test -f ~/.ssh/id_rsa; then
my_keytype='rsa'
if ! test -f ~/.ssh/id_rsa.pub; then
echo >&2 ""
ssh-keygen -y -f ~/.ssh/id_rsa > ~/.ssh/id_rsa.pub
fi
elif test -f ~/.ssh/id_ecda; then
my_keytype='ecdsa'
if ! test -f ~/.ssh/id_ecdsa.pub; then
echo >&2 ""
ssh-keygen -y -f ~/.ssh/id_ecda > ~/.ssh/id_ecda.pub
fi
else
my_keytype='rsa'
echo >&2 "" echo >&2 ""
ssh-keygen -b 4096 -t rsa -f ~/.ssh/id_rsa -q -N ""
ssh-keygen -y -f ~/.ssh/id_rsa > ~/.ssh/id_rsa.pub
fi fi
if [ ! -f "$HOME/.ssh/id_rsa.pub" ]; then my_comment="$(tr '[:space:]' '\n' < "$HOME/.ssh/id_${my_keytype}.pub" | grep '\w' | tail -n 1)"
ssh-keygen -y -f "$HOME/.ssh/id_rsa" > "$HOME/.ssh/id_rsa.pub" if test -z "${my_comment}" || test "${my_comment#}" -gt 100; then
echo >&2 "" my_comment="$(id -u -n)"
fi fi
# TODO use the comment (if any) for the name of the file
echo >&2 "" echo >&2 ""
#shellcheck disable=SC2088 #shellcheck disable=SC2088
echo >&2 "~/Downloads/id_rsa.$(whoami).pub": echo >&2 "~/Downloads/id_${my_keytype}.${my_comment}.pub":
echo >&2 "" echo >&2 ""
rm -f "$HOME/Downloads/id_rsa.$(whoami).pub" rm -f "$HOME/Downloads/id_${my_keytype}.${my_comment}.pub"
cp -r "$HOME/.ssh/id_rsa.pub" "$HOME/Downloads/id_rsa.$(whoami).pub" cp -RPp "$HOME/.ssh/id_${my_keytype}.pub" "$HOME/Downloads/id_${my_keytype}.${my_comment}.pub"
cat "$HOME/Downloads/id_rsa.$(whoami).pub" cat "$HOME/Downloads/id_${my_keytype}.${my_comment}.pub"
echo >&2 "" echo >&2 ""
if test -f ~/.ssh/id_rsa; then
my_rsa_size="$(wc < ~/.ssh/id_rsa | rev | cut -d' ' -f1 | rev)"
if test "${my_rsa_size}" -lt 2500; then
fn_warn_rsa >&2
echo >&2 ""
fi
fi
} }
main main

View File

@@ -1,12 +0,0 @@
vim README.md
vim _webi/template.ps1
vim _webi/template.sh
vim brew/install.sh
vim git/install.ps1
vim golang/install.ps1
vim golang/install.sh
vim node/install.ps1
vim postgres/install.sh
vim sass/install.ps1
vim webi/install.sh
vim zig/install.ps1

View File

@@ -1,7 +1,6 @@
#!/bin/sh #!/bin/sh
set -e set -e
set -u set -u
#set -x
fn_install_webi_essentials_macos() { ( fn_install_webi_essentials_macos() { (
# streamline the output to be pretty # streamline the output to be pretty
@@ -181,7 +180,7 @@ _install_webi_essentials() { (
fi fi
fi fi
printf '%s' " $(t_dim 'Checking for apt/apk ...')" printf '%s' " $(t_dim 'Checking for apt/apk/pkg_add ...')"
if command -v apt > /dev/null; then if command -v apt > /dev/null; then
echo " $(t_pkg 'apt')" echo " $(t_pkg 'apt')"
_install_webi_essentials_apt "${cmd_sudo}" "${b_pkgs}" _install_webi_essentials_apt "${cmd_sudo}" "${b_pkgs}"
@@ -196,6 +195,13 @@ _install_webi_essentials() { (
return 0 return 0
fi fi
if command -v pkg_add > /dev/null; then
echo " $(t_pkg 'pkg_add')"
_install_webi_essentials_pkg_add "${cmd_sudo}" "${b_pkgs}"
echo " $(t_dim 'OK')"
return 0
fi
echo " $(t_dim 'none')" echo " $(t_dim 'none')"
_install_webi_essentials_webi "${cmd_sudo}" "${b_pkgs}" _install_webi_essentials_webi "${cmd_sudo}" "${b_pkgs}"
echo " $(t_dim 'OK')" echo " $(t_dim 'OK')"
@@ -231,11 +237,21 @@ _install_webi_essentials_apk() { (
${cmd_sudo} apk add --no-cache ${b_pkgs} ${cmd_sudo} apk add --no-cache ${b_pkgs}
); } ); }
_install_webi_essentials_pkg_add() { (
cmd_sudo="${1}"
b_pkgs="${2}"
echo " $(t_dim 'Running') $(t_cmd "${cmd_sudo}pkg_add")"
fn_polite_sudo "${cmd_sudo}" " $(t_cmd "pkg_add ${b_pkgs}")"
# shellcheck disable=SC2086
${cmd_sudo} pkg_add ${b_pkgs}
); }
_install_webi_essentials_webi() { ( _install_webi_essentials_webi() { (
cmd_sudo="${1}" cmd_sudo="${1}"
b_pkgs="${2}" b_pkgs="${2}"
if test "${b_pkgs}" == 'xz'; then if test "${b_pkgs}" = 'xz'; then
~/.local/bin/webi xz ~/.local/bin/webi xz
return 0 return 0
fi fi

View File

@@ -133,7 +133,7 @@ Push-Location $Env:USERPROFILE
New-Item -Path "$HOME\.local\bin\" -ItemType Directory -Force | Out-Null New-Item -Path "$HOME\.local\bin\" -ItemType Directory -Force | Out-Null
# See note on Set-ExecutionPolicy above # See note on Set-ExecutionPolicy above
Set-Content -Path "$HOME\.local\bin\webi.bat" -Value "@echo off`r`npowershell -ExecutionPolicy Bypass %USERPROFILE%\.local\bin\webi-pwsh.ps1 %*" Set-Content -Path "$HOME\.local\bin\webi.bat" -Value "@echo off`r`npowershell -ExecutionPolicy Bypass -File `"%USERPROFILE%\.local\bin\webi-pwsh.ps1`" %*"
# Backwards-compat bugfix: remove old webi-pwsh.ps1 location # Backwards-compat bugfix: remove old webi-pwsh.ps1 location
Remove-Item -Path "$HOME\.local\bin\webi.ps1" -Recurse -ErrorAction Ignore Remove-Item -Path "$HOME\.local\bin\webi.ps1" -Recurse -ErrorAction Ignore
if (!(Test-Path -Path "$HOME\.local\opt")) { if (!(Test-Path -Path "$HOME\.local\opt")) {
@@ -199,7 +199,7 @@ $UrlParams = "formats=zip,exe,tar,git&libc=msvc"
$PkgInstallPwsh = "$HOME\.local\tmp\$exename.install.ps1" $PkgInstallPwsh = "$HOME\.local\tmp\$exename.install.ps1"
Invoke-DownloadUrl -Force -URL $PKG_URL -Params $UrlParams -Path $PkgInstallPwsh Invoke-DownloadUrl -Force -URL $PKG_URL -Params $UrlParams -Path $PkgInstallPwsh
powershell $HOME\.local\tmp\${exename}.install.ps1 powershell -File "$HOME\.local\tmp\${exename}.install.ps1"
IF ($IsWebiParent) { IF ($IsWebiParent) {
Write-Host "" Write-Host ""

View File

@@ -63,10 +63,11 @@ __webi_main() {
export WEBI_URL export WEBI_URL
set -e set -e
my_uname_o="$(uname -o 2> /dev/null || echo '')"
my_libc='' my_libc=''
if ldd /bin/ls 2> /dev/null | grep -q 'musl' 2> /dev/null; then if ldd /bin/ls 2> /dev/null | grep -q 'musl' 2> /dev/null; then
my_libc='musl' my_libc='musl'
elif uname -o | grep -q 'GNU' || uname -s | grep -q 'Linux'; then elif echo "${my_uname_o}" | grep -q 'GNU' || uname -s | grep -q 'Linux'; then
my_libc='gnu' my_libc='gnu'
else else
my_libc='libc' my_libc='libc'
@@ -141,16 +142,30 @@ __webi_main() {
} }
fn_checksum() { fn_checksum() {
cmd_shasum='sha1sum' a_filepath="${1}"
if command -v shasum > /dev/null; then
cmd_shasum='shasum' if command -v sha1sum > /dev/null; then
sha1sum "${a_filepath}" | cut -d' ' -f1 | cut -c 1-8
return 0
fi fi
$cmd_shasum "${0}" | cut -d' ' -f1 | cut -c 1-8
if command -v shasum > /dev/null; then
shasum "${a_filepath}" | cut -d' ' -f1 | cut -c 1-8
return 0
fi
if command -v sha1 > /dev/null; then
sha1 "${a_filepath}" | cut -d'=' -f2 | cut -c 2-9
return 0
fi
echo >&2 " warn: no sha1 sum program"
date '+%F %H:%M'
} }
version() { version() {
my_checksum="$( my_checksum="$(
fn_checksum fn_checksum "${0}"
)" )"
my_version=v1.2.8 my_version=v1.2.8
printf "\e[35mwebi\e[32m %s\e[0m Copyright 2020+ AJ ONeal\n" "${my_version} (${my_checksum})" printf "\e[35mwebi\e[32m %s\e[0m Copyright 2020+ AJ ONeal\n" "${my_version} (${my_checksum})"

1
xcode-cli Symbolic link
View File

@@ -0,0 +1 @@
commandlinetools